/*
    This file is part of the CLib sub-project of the FreeDOS project
    Copyright (C) 1997 by the author see below

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: TELL.C $
   $Locker:  $	$Name:  $	$State: Exp $

	off_t tell(int fd)

	Return the current position of the filepointer (the offset of the
	file from "whence" == SEEK_SET).

	Input:
		<none>

	Return:
		-1 on failure
		else: current filepointer

	Note:
		<none>

	Conforms to:
		Posix

	See also:
		lseek, open

	Target compilers:
		Any C compiler

	Origin:
		1997/10/10 Steffen Kaiser (ska)

	Revised by:
		<none>

	File Revision:    Revision 1.1  1997/10/13 07:06:59  ska
*/

#include <_clib.h>			/* standard include, must be the first! */
#include <io.h>

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: TELL.C 1.1 1997/10/13 07:06:59 ska Exp $";
#endif

_CLibFunc off_t
tell(const int fd)
{	return lseek(fd, (off_t)0, SEEK_CUR);
}
