;
;     Free DOS Alternative Kernel;  FDBOOT v. 1.10 (01-06-98)
;
;     =               Make Boot Record Utility              =
;
;               by Yury Semenov (yury@ultra.paco.net)
;

INCLUDE FDBOOT.INC

EXTRN FDBOOT_ENTRY:FAR

STACK	SEGMENT WORD STACK 'STACK'
         DB 100h DUP (0)
STACK	ENDS

DATA	SEGMENT BYTE PUBLIC 'DATA'

OldStyle DB 0

Drive    DB 0

TransferPacketOut LABEL WORD
         DD 0
         DW 1
WriteBuffer LABEL DWORD
         DW offset FDBOOT_ENTRY
         DW seg    FDBOOT_ENTRY

TransferPacketInp LABEL WORD
         DD 0
         DW 1
ReadBuffer LABEL DWORD
         DW offset OldBoot
         DW seg    OldBoot

OldBoot  DB 512 DUP(?)

Tmpfname DB "boot.tmp",0

DATA	ENDS

CSEG	SEGMENT BYTE PUBLIC 'CODE'
ASSUME CS:CSEG, DS:DATA
 Start: cmp	al,-1
 	mov	dx,offset InvDr
 	jz	Usage0
        cmp	byte ptr ds:[5ch],0
        jz	Usage0
        mov	di,5dh
        call	ChkStr
        jnz	KernNam
        mov	di,6dh
        call	ChkStr
 	mov	dx,offset InvPar
Usage0:	jnz	KernNam
	jmp	Usage
KernNam:
	mov	si,di
        mov	ax,seg FDBOOT_ENTRY
        mov	es,ax
        mov	cx,11
        push	si
        push	cx
        mov	di,488    ; XBoot Name offset in FDBOOT Boot Sector
        rep	cmpsb
        pop	cx
        pop	si
        mov	dx,offset IllKer
        jnz	KrOk
        jmp	GenErr
KrOk:   mov	di,499    ; Default Kernel Name offset in FDBOOT Boot Sector
        rep	movsb
        mov	dl,ds:[5ch]
 	mov	ax,DATA
        dec	dl
 	mov	ds,ax
        mov	Drive,dl
 	mov	ah,30h
 	int	21h
        cmp	al,4
        jae	V4plus
        mov	OldStyle,1
 V4plus:
        call	Read
        mov	dx,offset ReadErr
        jc	GenErr

        push	si
        lds	si,ReadBuffer       ; Here we must to preserve original
        cmp	[si+3].ExtBoot,29h  ; Boot Record data...
        pushf
        add	si,11
        les	di,WriteBuffer
        add	di,11
        mov	cx,51           ; (Extended boot record - OEM) size
        popf
        pushf
        jz	XBoot
        mov	cx,19           ; else get only 19 bytes
XBoot:
        cld
        rep	movsb
        popf
        pop	si
        jz	DoWrite 
        add	si,3            ; No Ext. Sig. - correct FileSys ID
        xor	dx,dx
        mov	cx,ClustSz
        mov	ax,[si].TotSec
        or	ax,ax
        jnz	SecOk
        mov	ax,word ptr [si].TotSecLong
        mov	dx,word ptr [si].TotSecLong+2
SecOk:  div	cx
	cmp	ax,0ff6h
        jbe	DoWrite
FAT16:	mov	byte ptr [si].FileSysID+4,"6"
DoWrite:
	call	Write

        jnc	Exit
        mov	dx,offset WProErr
        cmp	ah,3
        jz	GenErr
        mov	dx,offset WriteErr
        jmp	GenErr

 Exit:	mov	al,0
 Exi:	mov	ah,4ch
 	int	21h

 GenErr:
 	call	Error
        jmp	Exi

 Usage: call	Error
        push	ax
        mov	dx,offset UsageMes
        mov	ah,9
        int	21h
	pop	ax
        jmp	Exi
ME	 DB	"MKBOOT 1.10 :  $"

InvPar	 DB	1,"Invalid Parameters",13,10,"$"
InvDr	 DB	2,"Invalid Drive",13,10,"$"
IllKer   DB	3,"Illegal Kernel Name",13,10,"$"
ReadErr  DB	4,"Can't read boot sector",13,10,"$"
WriteErr DB	5,"Can't write boot sector",13,10,"$"
WProErr  DB	6,"Attempting write to write-protected disk",13,10,"$"

UsageMes DB	10," Usage:  mkboot  <drive>: <default.kernel>",13,10,"$"

Error  PROC NEAR
	push	cs
 	pop	ds
        push	dx
        mov	dx,offset ME
        mov	ah,9
        int	21h
        pop	dx
        mov	bx,dx
        inc	dx
        push	word ptr [bx]
        mov	ah,9
        int	21h
        pop	ax
        ret
Error  ENDP

ChkStr PROC NEAR
	push	di
        mov	al,' '
        mov	cx,11
        cld
        rep	scasb
        pop	di
        ret
ChkStr ENDP

Read   PROC NEAR
        mov	al,Drive
        mov	bx,offset TransferPacketInp
        cmp	OldStyle,0
        jnz	OldRead
        mov	cx,-1
        int	25h
        pop	cx
	ret
OldRead:
        push	ds
        mov	dx,word ptr [bx]
        mov	cx,word ptr [bx+4]
        lds	bx,dword ptr [bx+6]
        int	25h
        pop	cx
        pop	ds
	ret
Read   ENDP

Write  PROC NEAR
	mov	al,Drive
        mov	bx,offset TransferPacketOut
        cmp	OldStyle,0
        jnz	OldWrite
        mov	cx,-1
        int	26h
        pop	cx
	ret
OldWrite:
        push	ds
        mov	dx,word ptr [bx]
        mov	cx,word ptr [bx+4]
        lds	bx,dword ptr [bx+6]
        int	26h
        pop	cx
        pop	ds
	ret
Write  ENDP

CSEG	ENDS

	END Start
